/*  Copyright (c) 2024 by soruce <soruce ~ AT ~ soruce.net>

    This file is part of the Arduino PimientoClockLib Library.

    The Arduino PimientoClockLib Library is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The Arduino PimientoClockLib Library is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Arduino PimientoClockLib Library.  If not, see
    <http://www.gnu.org/licenses/>.
*/

/**
 * This font only contains the characters 0-9 and can be used to display a minimal digital clock face.
*/
#include "Font2.h"

// preinstantiated font class
Font2 font2;

const char font2_data[] PROGMEM = {
    0x3E, 0x7F, 0x71, 0x59, 0x4D, 0x7F, 0x3E,  // 0x30 (0)
    0x40, 0x42, 0x7F, 0x7F, 0x40, 0x40, 0x00,  // 0x31 (1)
    0x62, 0x73, 0x59, 0x49, 0x6F, 0x66, 0x00,  // 0x32 (2)
    0x22, 0x63, 0x49, 0x49, 0x7F, 0x36, 0x00,  // 0x33 (3)
    0x18, 0x1C, 0x16, 0x53, 0x7F, 0x7F, 0x50,  // 0x34 (4)
    0x27, 0x67, 0x45, 0x45, 0x7D, 0x39, 0x00,  // 0x35 (5)
    0x3C, 0x7E, 0x4B, 0x49, 0x79, 0x30, 0x00,  // 0x36 (6)
    0x03, 0x03, 0x71, 0x79, 0x0F, 0x07, 0x00,  // 0x37 (7)
    0x36, 0x7F, 0x49, 0x49, 0x7F, 0x36, 0x00,  // 0x38 (8)
    0x06, 0x4F, 0x49, 0x69, 0x3F, 0x1E, 0x00,  // 0x39 (9)
};

uint8_t Font2::getCharWidth() {
  return CHAR_DATA_WIDTH;
}

uint8_t Font2::getCharHeight() {
  return CHAR_HEIGHT;
}

uint8_t Font2::getCharWidth(char c) {
  return CHAR_DATA_WIDTH;
}

uint8_t Font2::getSpacingBetweenChars() {
  return SPACING_BETWEEN_CHARS;
}

char Font2::getColumnData(char c, uint8_t column) {
  char c2 = (c >= START_CHAR && c <= END_CHAR) ? c : UNKNOWN_CHAR;
  return pgm_read_byte(&(font2_data[(c2 - START_CHAR) * CHAR_DATA_WIDTH + column]));
}

