/*  Copyright (c) 2024 by soruce <soruce ~ AT ~ soruce.net>

    This file is part of the Arduino PimientoClockLib Library.

    The Arduino PimientoClockLib Library is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The Arduino PimientoClockLib Library is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Arduino PimientoClockLib Library.  If not, see
    <http://www.gnu.org/licenses/>.
*/

/**
 * This font only contains the characters 0-9 and can be used to display a minimal digital clock face.
*/

#include "Font3.h"

// preinstantiated font class
Font3 font3;

const char font3_data[] PROGMEM = {

    0xFF, 0x81, 0x81, 0x81, 0x81, 0x81, 0xFF,   // 0x30 (0)
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF,   // 0x31 (1)
    0xF9, 0x89, 0x89, 0x89, 0x89, 0x89, 0x8F,   // 0x32 (2)
    0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0xFF,   // 0x33 (3)
    0x0F, 0x08, 0x08, 0x08, 0x08, 0x08, 0xFF,   // 0x34 (4)
    0x8F, 0x89, 0x89, 0x89, 0x89, 0x89, 0xF9,   // 0x35 (5) 
    0xFF, 0x89, 0x89, 0x89, 0x89, 0x89, 0xF9,   // 0x36 (6)
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0xFF,   // 0x37 (7)
    0xFF, 0x89, 0x89, 0x89, 0x89, 0x89, 0xFF,   // 0x38 (8)
    0x8F, 0x89, 0x89, 0x89, 0x89, 0x89, 0xFF,   // 0x39 (9) 
};

uint8_t Font3::getCharWidth() {
  return CHAR_DATA_WIDTH;
}

uint8_t Font3::getCharHeight() {
  return CHAR_HEIGHT;
}

uint8_t Font3::getCharWidth(char c) {
  return CHAR_DATA_WIDTH;
}

uint8_t Font3::getSpacingBetweenChars() {
  return SPACING_BETWEEN_CHARS;
}

char Font3::getColumnData(char c, uint8_t column) {
  char c2 = (c >= START_CHAR && c <= END_CHAR) ? c : UNKNOWN_CHAR;
  return pgm_read_byte(&(font3_data[(c2 - START_CHAR) * CHAR_DATA_WIDTH + column]));
}

