/*  Copyright (c) 2024 by soruce <soruce ~ AT ~ soruce.net>

    This file is part of the Arduino PimientoClockLib Library.

    The Arduino PimientoClockLib Library is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The Arduino PimientoClockLib Library is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Arduino PimientoClockLib Library.  If not, see
    <http://www.gnu.org/licenses/>.
*/

/**
 * https://fontstruct.com/fontstructions/show/1371235/3x5-dot-matrix-1
 * This font only contains the characters 0-9 and can be used to display a minimal digital clock face.
*/

#include "Font4.h"

// preinstantiated font class
Font4 font4;

const char font4_data[] PROGMEM = {

    0x1F, 0x11, 0x1F,   // 0x30 (0) 
    0x11, 0x1F, 0x10,   // 0x31 (1)
    0x1D, 0x15, 0x17,   // 0x32 (2) 
    0x15, 0x15, 0x1F,   // 0x33 (3)
    0x0C, 0x0A, 0x1F,   // 0x34 (4)
    0x17, 0x15, 0x1D,   // 0x35 (5)
    0x1E, 0x15, 0x1C,   // 0x36 (6)
    0x19, 0x05, 0x03,   // 0x37 (7)
    0x1F, 0x15, 0x1F,   // 0x38 (8)
    0x07, 0x15, 0x0F,   // 0x39 (9)
};

uint8_t Font4::getCharWidth() {
  return CHAR_DATA_WIDTH;
}

uint8_t Font4::getCharHeight() {
  return CHAR_HEIGHT;
}

uint8_t Font4::getCharWidth(char c) {
  return CHAR_DATA_WIDTH;
}

uint8_t Font4::getSpacingBetweenChars() {
  return SPACING_BETWEEN_CHARS;
}

char Font4::getColumnData(char c, uint8_t column) {
  char c2 = (c >= START_CHAR && c <= END_CHAR) ? c : UNKNOWN_CHAR;
  return pgm_read_byte(&(font4_data[(c2 - START_CHAR) * CHAR_DATA_WIDTH + column]));
}

